package com.duoqio.actuatorshiro.shiro.realm;


import org.apache.shiro.authc.AuthenticationException;
import org.apache.shiro.authc.AuthenticationInfo;
import org.apache.shiro.authc.AuthenticationToken;
import org.apache.shiro.authz.AuthorizationInfo;
import org.apache.shiro.authz.SimpleAuthorizationInfo;
import org.apache.shiro.realm.AuthorizingRealm;
import org.apache.shiro.subject.PrincipalCollection;
import org.springframework.beans.factory.annotation.Autowired;

import com.duoqio.actuatorshiro.data.service.DataService;

/**
 *  shiro realm , like Secure data source <br>
 *  
 *  After my tests, I found that the problem appeared here <br>
 *  
 *  If I use the bean(@Autowired DataService dataService) with external injection to get the source data when I authenticate the user or get the user permissions, 
 *  I will not be able to get the JVM metric,But if I use the Bean(SpringContextUtil.getApplicationContext().getBean(DataService.class)) that ApplicationContext gets, 
 *  I can get it <br>
 *  
 *  Some other findings:When I delve into this problem, I have some other findings, I think the problem is likely to appear in the source data for DataServiceImpl this class, 
 *  because when I no longer injecting JPA to him beans(remove DataServiceImpl class 15 to 21 lines of code), I used in the Realm of custom external Bean can still get the JVM metric, 
 *  you can will be injected JPA DataServiceImpl Bean remove, you can find the problem, so it is a question of Shiro or Spring startup guide
 */
public class SecurityShiroRealm extends AuthorizingRealm {
	
	private @Autowired DataService dataService;
	
	/**
	 * Get permission information
	 */
	@Override
	protected AuthorizationInfo doGetAuthorizationInfo(PrincipalCollection principals) {
		SimpleAuthorizationInfo authorizationInfo = new SimpleAuthorizationInfo();
		@SuppressWarnings("unused")
		String userName = (String) principals.getPrimaryPrincipal();
		//external injection get source data
		dataService.getData();
		//ApplicationContext get source data
//		DataService dataService = SpringContextUtil.getApplicationContext().getBean(DataService.class);
//		dataService.getData();
		return authorizationInfo;
	}

	
	/**
	 * Certified user information
	 */
	@Override
	protected AuthenticationInfo doGetAuthenticationInfo(AuthenticationToken token) throws AuthenticationException {
		@SuppressWarnings("unused")
		String userName = (String) token.getPrincipal();
		//get source data
		dataService.getData();
		//ApplicationContext get source data
//		DataService dataService = SpringContextUtil.getApplicationContext().getBean(DataService.class);
//		dataService.getData();
		return null;
	}

}
